<template lang="html">
  <div id="image-uploader">
    <div id="image-uploader-btn" v-if="!inputData">
      <button class="button is-link is-medium" @click="">Ajouter une image</button>
      <input type="file" name="resume" @change="getInputFile($event)" />
    </div>
    <div id="image-uploader-form" v-else >
      <div id="form">
        <img :src="inputData.blob" />
        <b-field label="Quelques mots à propos de cette image">
           <b-input type="textarea" v-model="newImg.description" placeholder="Cette chanson parle..."></b-input>
        </b-field>
       <b-field label="Quelques tags pour relever la sauce">
         <b-taginput
             v-model="newImg.tags"
             placeholder="dance ...">
         </b-taginput>
       </b-field>
       <div class="field">
         <div class="control">
           <button class="button is-link is-medium" @click="addImage()">Valider</button>
           <button class="button is-medium is-outlined" @click="flushLocalsData()">Annuler</button>
         </div>
       </div>
      </div>
    </div>
  </div>
</template>

<script>
import { getInputFile } from '@/assets/utils'
import Api from '@/api/Api'
import { mapMutations } from 'vuex'
import musicGenders from '@/assets/music-genders.json'
export default {
  name:'ImageUploader',
  props:['compositor'],
  data(){
    return{
        newImg:{
          creator:this.compositor._id,
          tags:[],
          description:null,
          url:null,
          date:null
        },
        inputData:null
    }
  },
  computed:{

  },
  methods:{
    ...mapMutations('profile',['addNewPost']),
    getInputFile(event){
      if(getInputFile(event)){
        this.inputData = getInputFile(event);
        this.newImg.url = Date.now().toString()+'_'+this.compositor._id+'.jpg';
      }
    },
    addImage(){
      this.newImg.date = Date.now();
      return Api.posts().post('/add_post',this.newImg).then((res) =>
        {

          this.uploadNewImage();

        }).catch((res) => {
          return false;
        })
    },
    uploadNewImage(){
      const formData = new FormData();
      formData.append("uploads[]", this.inputData.input, this.newImg.url);
      return Api.posts().post('/upload_img_post',formData,{
    onUploadProgress: progressEvent => {
      var score = (progressEvent.loaded / progressEvent.total)*100
      if(score == 100){
        this.addNewPost(this.newImg);
        this.flushLocalsData();
      }
    }}
).then((res) =>
        {
          return true
        }).catch((res) => {
          return false
        })
    },
    flushLocalsData(){
      this.newImg = {
        creator:this.compositor._id,
        tags:[],
        description:null,
        url:null,
        date:null
      },
      this.inputData = null;
    }
  }
}
</script>

<style lang="scss" scoped>
#image-uploader {
  display: flex;
  align-items: center;
  justify-content: center;
  margin-bottom: 1.3rem;
  #image-uploader-btn{
    position: relative;
    display: flex;
    align-items: center;
    justify-content: center;
    button,input {
      width: 760px;
    }
    input{
      position: absolute;
      left: 0;
      top: 0;
      height: 100%;
      opacity: 0;
      cursor: pointer;
    }
  }

  #image-uploader-form {
    width: 760px;
    padding: 2rem;
    display: flex;
    flex-direction: column;
    align-items: center;
    border: 1px solid #dbdbdb;
    #form{
      width: 94%;
    }
  }

}
</style>
